Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.math3.linear
Interface RealMatrix

All Superinterfaces:
  AnyMatrix

All Known Subinterfaces:
  SparseRealMatrix

All Known Implementing Classes:
  AbstractRealMatrix, Array2DRowRealMatrix, BlockRealMatrix, DiagonalMatrix, OpenMapRealMatrix

    public interface RealMatrix

extends AnyMatrix

Interface defining a real-valued matrix with basic algebraic operations.

Matrix element indexing is 0-based -- e.g., `getEntry(0, 0)` returns the element in the first row, first column of the matrix.

Version:
  $Id: RealMatrix.java 1416643 2012-12-03 19:37:14Z tn $

Method Summary
`RealMatrix` | `add(RealMatrix m)` Returns the sum of `this` and `m`.
`void` | `addToEntry(int row, int column, double increment)` Adds (in place) the specified value to the specified entry of `this` matrix.
`RealMatrix` | `copy()` Returns a (deep) copy of this.
`void` | `copySubMatrix(int[] selectedRows, int[] selectedColumns, double[][] destination)` Copy a submatrix.
`void` | `copySubMatrix(int startRow, int endRow, int startColumn, int endColumn, double[][] destination)` Copy a submatrix.
`RealMatrix` | `createMatrix(int rowDimension, int columnDimension)` Create a new RealMatrix of the same type as the instance with the supplied row and column dimensions.
`double[]` | `getColumn(int column)` Get the entries at the given column index as an array.
`RealMatrix` | `getColumnMatrix(int column)` Get the entries at the given column index as a column matrix.
`RealVector` | `getColumnVector(int column)` Get the entries at the given column index as a vector.
`double[][]` | `getData()` Returns matrix entries as a two-dimensional array.
`double` | `getEntry(int row, int column)` Get the entry in the specified row and column.
`double` | `getFrobeniusNorm()` Returns the Frobenius norm of the matrix.
`double` | `getNorm()` Returns the maximum absolute row sum norm of the matrix.
`double[]` | `getRow(int row)` Get the entries at the given row index.
`RealMatrix` | `getRowMatrix(int row)` Get the entries at the given row index as a row matrix.
`RealVector` | `getRowVector(int row)` Returns the entries in row number `row` as a vector.
`RealMatrix` | `getSubMatrix(int[] selectedRows, int[] selectedColumns)` Gets a submatrix.
`RealMatrix` | `getSubMatrix(int startRow, int endRow, int startColumn, int endColumn)` Gets a submatrix.
`double` | `getTrace()` Returns the trace of the matrix (the sum of the elements on the main diagonal).
`RealMatrix` | `multiply(RealMatrix m)` Returns the result of postmultiplying `this` by `m`.
`void` | `multiplyEntry(int row, int column, double factor)` Multiplies (in place) the specified entry of `this` matrix by the specified value.
`double[]` | `operate(double[] v)` Returns the result of multiplying this by the vector `v`.
`RealVector` | `operate(RealVector v)` Returns the result of multiplying this by the vector `v`.
`RealMatrix` | `power(int p)` Returns the result of multiplying `this` with itself `p` times.
`double[]` | `preMultiply(double[] v)` Returns the (row) vector result of premultiplying this by the vector `v`.
`RealMatrix` | `preMultiply(RealMatrix m)` Returns the result of premultiplying `this` by `m`.
`RealVector` | `preMultiply(RealVector v)` Returns the (row) vector result of premultiplying this by the vector `v`.
`RealMatrix` | `scalarAdd(double d)` Returns the result of adding `d` to each entry of `this`.
`RealMatrix` | `scalarMultiply(double d)` Returns the result of multiplying each entry of `this` by `d`.
`void` | `setColumn(int column, double[] array)` Sets the specified `column` of `this` matrix to the entries of the specified `array`.
`void` | `setColumnMatrix(int column, RealMatrix matrix)` Sets the specified `column` of `this` matrix to the entries of the specified column `matrix`.
`void` | `setColumnVector(int column, RealVector vector)` Sets the specified `column` of `this` matrix to the entries of the specified `vector`.
`void` | `setEntry(int row, int column, double value)` Set the entry in the specified row and column.
`void` | `setRow(int row, double[] array)` Sets the specified `row` of `this` matrix to the entries of the specified `array`.
`void` | `setRowMatrix(int row, RealMatrix matrix)` Sets the specified `row` of `this` matrix to the entries of the specified row `matrix`.
`void` | `setRowVector(int row, RealVector vector)` Sets the specified `row` of `this` matrix to the entries of the specified `vector`.
`void` | `setSubMatrix(double[][] subMatrix, int row, int column)` Replace the submatrix starting at `row, column` using data in the input `subMatrix` array.
`RealMatrix` | `subtract(RealMatrix m)` Returns `this` minus `m`.
`RealMatrix` | `transpose()` Returns the transpose of this matrix.
`double` | `walkInColumnOrder(RealMatrixChangingVisitor visitor)` Visit (and possibly change) all matrix entries in column order.
`double` | `walkInColumnOrder(RealMatrixChangingVisitor visitor, int startRow, int endRow, int startColumn, int endColumn)` Visit (and possibly change) some matrix entries in column order.
`double` | `walkInColumnOrder(RealMatrixPreservingVisitor visitor)` Visit (but don't change) all matrix entries in column order.
`double` | `walkInColumnOrder(RealMatrixPreservingVisitor visitor, int startRow, int endRow, int startColumn, int endColumn)` Visit (but don't change) some matrix entries in column order.
`double` | `walkInOptimizedOrder(RealMatrixChangingVisitor visitor)` Visit (and possibly change) all matrix entries using the fastest possible order.
`double` | `walkInOptimizedOrder(RealMatrixChangingVisitor visitor, int startRow, int endRow, int startColumn, int endColumn)` Visit (and possibly change) some matrix entries using the fastest possible order.
`double` | `walkInOptimizedOrder(RealMatrixPreservingVisitor visitor)` Visit (but don't change) all matrix entries using the fastest possible order.
`double` | `walkInOptimizedOrder(RealMatrixPreservingVisitor visitor, int startRow, int endRow, int startColumn, int endColumn)` Visit (but don't change) some matrix entries using the fastest possible order.
`double` | `walkInRowOrder(RealMatrixChangingVisitor visitor)` Visit (and possibly change) all matrix entries in row order.
`double` | `walkInRowOrder(RealMatrixChangingVisitor visitor, int startRow, int endRow, int startColumn, int endColumn)` Visit (and possibly change) some matrix entries in row order.
`double` | `walkInRowOrder(RealMatrixPreservingVisitor visitor)` Visit (but don't change) all matrix entries in row order.
`double` | `walkInRowOrder(RealMatrixPreservingVisitor visitor, int startRow, int endRow, int startColumn, int endColumn)` Visit (but don't change) some matrix entries in row order.

Methods inherited from interface org.apache.commons.math3.linear.AnyMatrix
`getColumnDimension, getRowDimension, isSquare`

Method Detail

### createMatrix

    RealMatrix createMatrix(int rowDimension,
                            int columnDimension)
                            throws NotStrictlyPositiveException

  Create a new RealMatrix of the same type as the instance with the supplied row and column dimensions.

  Parameters:
    `rowDimension` - the number of rows in the new matrix
    `columnDimension` - the number of columns in the new matrix
  Returns:
    a new matrix of the same type as the instance
  Throws:
    `NotStrictlyPositiveException` - if row or column dimension is not positive.
  Since:
    2.0

### copy

    RealMatrix copy()

  Returns a (deep) copy of this.

  Returns:
    matrix copy

### add

    RealMatrix add(RealMatrix m)
                   throws MatrixDimensionMismatchException

  Returns the sum of `this` and `m`.

  Parameters:
    `m` - matrix to be added
  Returns:
    `this + m`
  Throws:
    `MatrixDimensionMismatchException` - if `m` is not the same size as `this`.

### subtract

    RealMatrix subtract(RealMatrix m)
                        throws MatrixDimensionMismatchException

  Returns `this` minus `m`.

  Parameters:
    `m` - matrix to be subtracted
  Returns:
    `this - m`
  Throws:
    `MatrixDimensionMismatchException` - if `m` is not the same size as `this`.

### scalarAdd

    RealMatrix scalarAdd(double d)

  Returns the result of adding `d` to each entry of `this`.

  Parameters:
    `d` - value to be added to each entry
  Returns:
    `d + this`

### scalarMultiply

    RealMatrix scalarMultiply(double d)

  Returns the result of multiplying each entry of `this` by `d`.

  Parameters:
    `d` - value to multiply all entries by
  Returns:
    `d * this`

### multiply

    RealMatrix multiply(RealMatrix m)
                        throws DimensionMismatchException

  Returns the result of postmultiplying `this` by `m`.

  Parameters:
    `m` - matrix to postmultiply by
  Returns:
    `this * m`
  Throws:
    `DimensionMismatchException` - if `columnDimension(this) != rowDimension(m)`

### preMultiply

    RealMatrix preMultiply(RealMatrix m)
                           throws DimensionMismatchException

  Returns the result of premultiplying `this` by `m`.

  Parameters:
    `m` - matrix to premultiply by
  Returns:
    `m * this`
  Throws:
    `DimensionMismatchException` - if `rowDimension(this) != columnDimension(m)`

### power

    RealMatrix power(int p)
                     throws NotPositiveException,
                            NonSquareMatrixException

  Returns the result of multiplying `this` with itself `p` times. Depending on the underlying storage, instability for high powers might occur.

  Parameters:
    `p` - raise `this` to power `p`
  Returns:
    `this^p`
  Throws:
    `NotPositiveException` - if `p < 0`
    `NonSquareMatrixException` - if the matrix is not square

### getData

    double[][] getData()

  Returns matrix entries as a two-dimensional array.

  Returns:
    2-dimensional array of entries

### getNorm

    double getNorm()

  Returns the maximum absolute row sum norm of the matrix.

  Returns:
    norm

### getFrobeniusNorm

    double getFrobeniusNorm()

  Returns the Frobenius norm of the matrix.

  Returns:
    norm

### getSubMatrix

    RealMatrix getSubMatrix(int startRow,
                            int endRow,
                            int startColumn,
                            int endColumn)
                            throws OutOfRangeException,
                                   NumberIsTooSmallException

  Gets a submatrix. Rows and columns are indicated counting from 0 to n-1.

  Parameters:
    `startRow` - Initial row index
    `endRow` - Final row index (inclusive)
    `startColumn` - Initial column index
    `endColumn` - Final column index (inclusive)
  Returns:
    The subMatrix containing the data of the specified rows and columns.
  Throws:
    `OutOfRangeException` - if the indices are not valid.
    `NumberIsTooSmallException` - if `endRow < startRow` or `endColumn < startColumn`.

### getSubMatrix

    RealMatrix getSubMatrix(int[] selectedRows,
                            int[] selectedColumns)
                            throws NullArgumentException,
                                   NoDataException,
                                   OutOfRangeException

  Gets a submatrix. Rows and columns are indicated counting from 0 to n-1.

  Parameters:
    `selectedRows` - Array of row indices.
    `selectedColumns` - Array of column indices.
  Returns:
    The subMatrix containing the data in the specified rows and columns
  Throws:
    `NullArgumentException` - if the row or column selections are `null`
    `NoDataException` - if the row or column selections are empty (zero length).
    `OutOfRangeException` - if the indices are not valid.

### copySubMatrix

    void copySubMatrix(int startRow,
                       int endRow,
                       int startColumn,
                       int endColumn,
                       double[][] destination)
                       throws OutOfRangeException,
                              NumberIsTooSmallException,
                              MatrixDimensionMismatchException

  Copy a submatrix. Rows and columns are indicated counting from 0 to n-1.

  Parameters:
    `startRow` - Initial row index
    `endRow` - Final row index (inclusive)
    `startColumn` - Initial column index
    `endColumn` - Final column index (inclusive)
    `destination` - The arrays where the submatrix data should be copied (if larger than rows/columns counts, only the upper-left part will be used)
  Throws:
    `OutOfRangeException` - if the indices are not valid.
    `NumberIsTooSmallException` - if `endRow < startRow` or `endColumn < startColumn`.
    `MatrixDimensionMismatchException` - if the destination array is too small.

### copySubMatrix

    void copySubMatrix(int[] selectedRows,
                       int[] selectedColumns,
                       double[][] destination)
                       throws OutOfRangeException,
                              NullArgumentException,
                              NoDataException,
                              MatrixDimensionMismatchException

  Copy a submatrix. Rows and columns are indicated counting from 0 to n-1.

  Parameters:
    `selectedRows` - Array of row indices.
    `selectedColumns` - Array of column indices.
    `destination` - The arrays where the submatrix data should be copied (if larger than rows/columns counts, only the upper-left part will be used)
  Throws:
    `NullArgumentException` - if the row or column selections are `null`
    `NoDataException` - if the row or column selections are empty (zero length).
    `OutOfRangeException` - if the indices are not valid.
    `MatrixDimensionMismatchException` - if the destination array is too small.

### setSubMatrix

    void setSubMatrix(double[][] subMatrix,
                      int row,
                      int column)
                      throws NoDataException,
                             OutOfRangeException,
                             DimensionMismatchException,
                             NullArgumentException

  Replace the submatrix starting at `row, column` using data in the input `subMatrix` array. Indexes are 0-based.

  Example:
  Starting with

       1  2  3  4
       5  6  7  8
       9  0  1  2

  and `subMatrix = {{3, 4} {5,6}}`, invoking `setSubMatrix(subMatrix,1,1))` will result in

       1  2  3  4
       5  3  4  8
       9  5  6  2

  Parameters:
    `subMatrix` - array containing the submatrix replacement data
    `row` - row coordinate of the top, left element to be replaced
    `column` - column coordinate of the top, left element to be replaced
  Throws:
    `NoDataException` - if `subMatrix` is empty.
    `OutOfRangeException` - if `subMatrix` does not fit into this matrix from element in `(row, column)`.
    `DimensionMismatchException` - if `subMatrix` is not rectangular (not all rows have the same length) or empty.
    `NullArgumentException` - if `subMatrix` is `null`.
  Since:
    2.0

### getRowMatrix

    RealMatrix getRowMatrix(int row)
                            throws OutOfRangeException

  Get the entries at the given row index as a row matrix. Row indices start at 0.

  Parameters:
    `row` - Row to be fetched.
  Returns:
    row Matrix.
  Throws:
    `OutOfRangeException` - if the specified row index is invalid.

### setRowMatrix

    void setRowMatrix(int row,
                      RealMatrix matrix)
                      throws OutOfRangeException,
                             MatrixDimensionMismatchException

  Sets the specified `row` of `this` matrix to the entries of the specified row `matrix`. Row indices start at 0.

  Parameters:
    `row` - Row to be set.
    `matrix` - Row matrix to be copied (must have one row and the same number of columns as the instance).
  Throws:
    `OutOfRangeException` - if the specified row index is invalid.
    `MatrixDimensionMismatchException` - if the row dimension of the `matrix` is not `1`, or the column dimensions of `this` and `matrix` do not match.

### getColumnMatrix

    RealMatrix getColumnMatrix(int column)
                               throws OutOfRangeException

  Get the entries at the given column index as a column matrix. Column indices start at 0.

  Parameters:
    `column` - Column to be fetched.
  Returns:
    column Matrix.
  Throws:
    `OutOfRangeException` - if the specified column index is invalid.

### setColumnMatrix

    void setColumnMatrix(int column,
                         RealMatrix matrix)
                         throws OutOfRangeException,
                                MatrixDimensionMismatchException

  Sets the specified `column` of `this` matrix to the entries of the specified column `matrix`. Column indices start at 0.

  Parameters:
    `column` - Column to be set.
    `matrix` - Column matrix to be copied (must have one column and the same number of rows as the instance).
  Throws:
    `OutOfRangeException` - if the specified column index is invalid.
    `MatrixDimensionMismatchException` - if the column dimension of the `matrix` is not `1`, or the row dimensions of `this` and `matrix` do not match.

### getRowVector

    RealVector getRowVector(int row)
                            throws OutOfRangeException

  Returns the entries in row number `row` as a vector. Row indices start at 0.

  Parameters:
    `row` - Row to be fetched.
  Returns:
    a row vector.
  Throws:
    `OutOfRangeException` - if the specified row index is invalid.

### setRowVector

    void setRowVector(int row,
                      RealVector vector)
                      throws OutOfRangeException,
                             MatrixDimensionMismatchException

  Sets the specified `row` of `this` matrix to the entries of the specified `vector`. Row indices start at 0.

  Parameters:
    `row` - Row to be set.
    `vector` - row vector to be copied (must have the same number of column as the instance).
  Throws:
    `OutOfRangeException` - if the specified row index is invalid.
    `MatrixDimensionMismatchException` - if the `vector` dimension does not match the column dimension of `this` matrix.

### getColumnVector

    RealVector getColumnVector(int column)
                               throws OutOfRangeException

  Get the entries at the given column index as a vector. Column indices start at 0.

  Parameters:
    `column` - Column to be fetched.
  Returns:
    a column vector.
  Throws:
    `OutOfRangeException` - if the specified column index is invalid

### setColumnVector

    void setColumnVector(int column,
                         RealVector vector)
                         throws OutOfRangeException,
                                MatrixDimensionMismatchException

  Sets the specified `column` of `this` matrix to the entries of the specified `vector`. Column indices start at 0.

  Parameters:
    `column` - Column to be set.
    `vector` - column vector to be copied (must have the same number of rows as the instance).
  Throws:
    `OutOfRangeException` - if the specified column index is invalid.
    `MatrixDimensionMismatchException` - if the `vector` dimension does not match the row dimension of `this` matrix.

### getRow

    double[] getRow(int row)
                    throws OutOfRangeException

  Get the entries at the given row index. Row indices start at 0.

  Parameters:
    `row` - Row to be fetched.
  Returns:
    the array of entries in the row.
  Throws:
    `OutOfRangeException` - if the specified row index is not valid.

### setRow

    void setRow(int row,
                double[] array)
                throws OutOfRangeException,
                       MatrixDimensionMismatchException

  Sets the specified `row` of `this` matrix to the entries of the specified `array`. Row indices start at 0.

  Parameters:
    `row` - Row to be set.
    `array` - Row matrix to be copied (must have the same number of columns as the instance)
  Throws:
    `OutOfRangeException` - if the specified row index is invalid.
    `MatrixDimensionMismatchException` - if the `array` length does not match the column dimension of `this` matrix.

### getColumn

    double[] getColumn(int column)
                       throws OutOfRangeException

  Get the entries at the given column index as an array. Column indices start at 0.

  Parameters:
    `column` - Column to be fetched.
  Returns:
    the array of entries in the column.
  Throws:
    `OutOfRangeException` - if the specified column index is not valid.

### setColumn

    void setColumn(int column,
                   double[] array)
                   throws OutOfRangeException,
                          MatrixDimensionMismatchException

  Sets the specified `column` of `this` matrix to the entries of the specified `array`. Column indices start at 0.

  Parameters:
    `column` - Column to be set.
    `array` - Column array to be copied (must have the same number of rows as the instance).
  Throws:
    `OutOfRangeException` - if the specified column index is invalid.
    `MatrixDimensionMismatchException` - if the `array` length does not match the row dimension of `this` matrix.

### getEntry

    double getEntry(int row,
                    int column)
                    throws OutOfRangeException

  Get the entry in the specified row and column. Row and column indices start at 0.

  Parameters:
    `row` - Row index of entry to be fetched.
    `column` - Column index of entry to be fetched.
  Returns:
    the matrix entry at `(row, column)`.
  Throws:
    `OutOfRangeException` - if the row or column index is not valid.

### setEntry

    void setEntry(int row,
                  int column,
                  double value)
                  throws OutOfRangeException

  Set the entry in the specified row and column. Row and column indices start at 0.

  Parameters:
    `row` - Row index of entry to be set.
    `column` - Column index of entry to be set.
    `value` - the new value of the entry.
  Throws:
    `OutOfRangeException` - if the row or column index is not valid
  Since:
    2.0

### addToEntry

    void addToEntry(int row,
                    int column,
                    double increment)
                    throws OutOfRangeException

  Adds (in place) the specified value to the specified entry of `this` matrix. Row and column indices start at 0.

  Parameters:
    `row` - Row index of the entry to be modified.
    `column` - Column index of the entry to be modified.
    `increment` - value to add to the matrix entry.
  Throws:
    `OutOfRangeException` - if the row or column index is not valid.
  Since:
    2.0

### multiplyEntry

    void multiplyEntry(int row,
                       int column,
                       double factor)
                       throws OutOfRangeException

  Multiplies (in place) the specified entry of `this` matrix by the specified value. Row and column indices start at 0.

  Parameters:
    `row` - Row index of the entry to be modified.
    `column` - Column index of the entry to be modified.
    `factor` - Multiplication factor for the matrix entry.
  Throws:
    `OutOfRangeException` - if the row or column index is not valid.
  Since:
    2.0

### transpose

    RealMatrix transpose()

  Returns the transpose of this matrix.

  Returns:
    transpose matrix

### getTrace

    double getTrace()
                    throws NonSquareMatrixException

  Returns the trace of the matrix (the sum of the elements on the main diagonal).

  Returns:
    the trace.
  Throws:
    `NonSquareMatrixException` - if the matrix is not square.

### operate

    double[] operate(double[] v)
                     throws DimensionMismatchException

  Returns the result of multiplying this by the vector `v`.

  Parameters:
    `v` - the vector to operate on
  Returns:
    `this * v`
  Throws:
    `DimensionMismatchException` - if the length of `v` does not match the column dimension of `this`.

### operate

    RealVector operate(RealVector v)
                       throws DimensionMismatchException

  Returns the result of multiplying this by the vector `v`.

  Parameters:
    `v` - the vector to operate on
  Returns:
    `this * v`
  Throws:
    `DimensionMismatchException` - if the dimension of `v` does not match the column dimension of `this`.

### preMultiply

    double[] preMultiply(double[] v)
                         throws DimensionMismatchException

  Returns the (row) vector result of premultiplying this by the vector `v`.

  Parameters:
    `v` - the row vector to premultiply by
  Returns:
    `v * this`
  Throws:
    `DimensionMismatchException` - if the length of `v` does not match the row dimension of `this`.

### preMultiply

    RealVector preMultiply(RealVector v)
                           throws DimensionMismatchException

  Returns the (row) vector result of premultiplying this by the vector `v`.

  Parameters:
    `v` - the row vector to premultiply by
  Returns:
    `v * this`
  Throws:
    `DimensionMismatchException` - if the dimension of `v` does not match the row dimension of `this`.

### walkInRowOrder

    double walkInRowOrder(RealMatrixChangingVisitor visitor)

  Visit (and possibly change) all matrix entries in row order.

  Row order starts at upper left and iterating through all elements of a row from left to right before going to the leftmost element of the next row.

  Parameters:
    `visitor` - visitor used to process all matrix entries
  Returns:
    the value returned by `RealMatrixChangingVisitor.end()` at the end of the walk
  See Also:
    `walkInRowOrder(RealMatrixPreservingVisitor)`, `walkInRowOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInRowOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `walkInColumnOrder(RealMatrixChangingVisitor)`, `walkInColumnOrder(RealMatrixPreservingVisitor)`, `walkInColumnOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInColumnOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `walkInOptimizedOrder(RealMatrixChangingVisitor)`, `walkInOptimizedOrder(RealMatrixPreservingVisitor)`, `walkInOptimizedOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInOptimizedOrder(RealMatrixPreservingVisitor, int, int, int, int)`

### walkInRowOrder

    double walkInRowOrder(RealMatrixPreservingVisitor visitor)

  Visit (but don't change) all matrix entries in row order.

  Row order starts at upper left and iterating through all elements of a row from left to right before going to the leftmost element of the next row.

  Parameters:
    `visitor` - visitor used to process all matrix entries
  Returns:
    the value returned by `RealMatrixPreservingVisitor.end()` at the end of the walk
  See Also:
    `walkInRowOrder(RealMatrixChangingVisitor)`, `walkInRowOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInRowOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `walkInColumnOrder(RealMatrixChangingVisitor)`, `walkInColumnOrder(RealMatrixPreservingVisitor)`, `walkInColumnOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInColumnOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `walkInOptimizedOrder(RealMatrixChangingVisitor)`, `walkInOptimizedOrder(RealMatrixPreservingVisitor)`, `walkInOptimizedOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInOptimizedOrder(RealMatrixPreservingVisitor, int, int, int, int)`

### walkInRowOrder

    double walkInRowOrder(RealMatrixChangingVisitor visitor,
                          int startRow,
                          int endRow,
                          int startColumn,
                          int endColumn)
                          throws OutOfRangeException,
                                 NumberIsTooSmallException

  Visit (and possibly change) some matrix entries in row order.

  Row order starts at upper left and iterating through all elements of a row from left to right before going to the leftmost element of the next row.

  Parameters:
    `visitor` - visitor used to process all matrix entries
    `startRow` - Initial row index
    `endRow` - Final row index (inclusive)
    `startColumn` - Initial column index
    `endColumn` - Final column index
  Returns:
    the value returned by `RealMatrixChangingVisitor.end()` at the end of the walk
  Throws:
    `OutOfRangeException` - if the indices are not valid.
    `NumberIsTooSmallException` - if `endRow < startRow` or `endColumn < startColumn`.
  See Also:
    `walkInRowOrder(RealMatrixChangingVisitor)`, `walkInRowOrder(RealMatrixPreservingVisitor)`, `walkInRowOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `walkInColumnOrder(RealMatrixChangingVisitor)`, `walkInColumnOrder(RealMatrixPreservingVisitor)`, `walkInColumnOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInColumnOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `walkInOptimizedOrder(RealMatrixChangingVisitor)`, `walkInOptimizedOrder(RealMatrixPreservingVisitor)`, `walkInOptimizedOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInOptimizedOrder(RealMatrixPreservingVisitor, int, int, int, int)`

### walkInRowOrder

    double walkInRowOrder(RealMatrixPreservingVisitor visitor,
                          int startRow,
                          int endRow,
                          int startColumn,
                          int endColumn)
                          throws OutOfRangeException,
                                 NumberIsTooSmallException

  Visit (but don't change) some matrix entries in row order.

  Row order starts at upper left and iterating through all elements of a row from left to right before going to the leftmost element of the next row.

  Parameters:
    `visitor` - visitor used to process all matrix entries
    `startRow` - Initial row index
    `endRow` - Final row index (inclusive)
    `startColumn` - Initial column index
    `endColumn` - Final column index
  Returns:
    the value returned by `RealMatrixPreservingVisitor.end()` at the end of the walk
  Throws:
    `OutOfRangeException` - if the indices are not valid.
    `NumberIsTooSmallException` - if `endRow < startRow` or `endColumn < startColumn`.
  See Also:
    `walkInRowOrder(RealMatrixChangingVisitor)`, `walkInRowOrder(RealMatrixPreservingVisitor)`, `walkInRowOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInColumnOrder(RealMatrixChangingVisitor)`, `walkInColumnOrder(RealMatrixPreservingVisitor)`, `walkInColumnOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInColumnOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `walkInOptimizedOrder(RealMatrixChangingVisitor)`, `walkInOptimizedOrder(RealMatrixPreservingVisitor)`, `walkInOptimizedOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInOptimizedOrder(RealMatrixPreservingVisitor, int, int, int, int)`

### walkInColumnOrder

    double walkInColumnOrder(RealMatrixChangingVisitor visitor)

  Visit (and possibly change) all matrix entries in column order.

  Column order starts at upper left and iterating through all elements of a column from top to bottom before going to the topmost element of the next column.

  Parameters:
    `visitor` - visitor used to process all matrix entries
  Returns:
    the value returned by `RealMatrixChangingVisitor.end()` at the end of the walk
  See Also:
    `walkInRowOrder(RealMatrixChangingVisitor)`, `walkInRowOrder(RealMatrixPreservingVisitor)`, `walkInRowOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInRowOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `walkInColumnOrder(RealMatrixPreservingVisitor)`, `walkInColumnOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInColumnOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `walkInOptimizedOrder(RealMatrixChangingVisitor)`, `walkInOptimizedOrder(RealMatrixPreservingVisitor)`, `walkInOptimizedOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInOptimizedOrder(RealMatrixPreservingVisitor, int, int, int, int)`

### walkInColumnOrder

    double walkInColumnOrder(RealMatrixPreservingVisitor visitor)

  Visit (but don't change) all matrix entries in column order.

  Column order starts at upper left and iterating through all elements of a column from top to bottom before going to the topmost element of the next column.

  Parameters:
    `visitor` - visitor used to process all matrix entries
  Returns:
    the value returned by `RealMatrixPreservingVisitor.end()` at the end of the walk
  See Also:
    `walkInRowOrder(RealMatrixChangingVisitor)`, `walkInRowOrder(RealMatrixPreservingVisitor)`, `walkInRowOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInRowOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `walkInColumnOrder(RealMatrixChangingVisitor)`, `walkInColumnOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInColumnOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `walkInOptimizedOrder(RealMatrixChangingVisitor)`, `walkInOptimizedOrder(RealMatrixPreservingVisitor)`, `walkInOptimizedOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInOptimizedOrder(RealMatrixPreservingVisitor, int, int, int, int)`

### walkInColumnOrder

    double walkInColumnOrder(RealMatrixChangingVisitor visitor,
                             int startRow,
                             int endRow,
                             int startColumn,
                             int endColumn)
                             throws OutOfRangeException,
                                    NumberIsTooSmallException

  Visit (and possibly change) some matrix entries in column order.

  Column order starts at upper left and iterating through all elements of a column from top to bottom before going to the topmost element of the next column.

  Parameters:
    `visitor` - visitor used to process all matrix entries
    `startRow` - Initial row index
    `endRow` - Final row index (inclusive)
    `startColumn` - Initial column index
    `endColumn` - Final column index
  Returns:
    the value returned by `RealMatrixChangingVisitor.end()` at the end of the walk
  Throws:
    `OutOfRangeException` - if the indices are not valid.
    `NumberIsTooSmallException` - if `endRow < startRow` or `endColumn < startColumn`.
  See Also:
    `walkInRowOrder(RealMatrixChangingVisitor)`, `walkInRowOrder(RealMatrixPreservingVisitor)`, `walkInRowOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInRowOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `walkInColumnOrder(RealMatrixChangingVisitor)`, `walkInColumnOrder(RealMatrixPreservingVisitor)`, `walkInColumnOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `walkInOptimizedOrder(RealMatrixChangingVisitor)`, `walkInOptimizedOrder(RealMatrixPreservingVisitor)`, `walkInOptimizedOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInOptimizedOrder(RealMatrixPreservingVisitor, int, int, int, int)`

### walkInColumnOrder

    double walkInColumnOrder(RealMatrixPreservingVisitor visitor,
                             int startRow,
                             int endRow,
                             int startColumn,
                             int endColumn)
                             throws OutOfRangeException,
                                    NumberIsTooSmallException

  Visit (but don't change) some matrix entries in column order.

  Column order starts at upper left and iterating through all elements of a column from top to bottom before going to the topmost element of the next column.

  Parameters:
    `visitor` - visitor used to process all matrix entries
    `startRow` - Initial row index
    `endRow` - Final row index (inclusive)
    `startColumn` - Initial column index
    `endColumn` - Final column index
  Returns:
    the value returned by `RealMatrixPreservingVisitor.end()` at the end of the walk
  Throws:
    `OutOfRangeException` - if the indices are not valid.
    `NumberIsTooSmallException` - if `endRow < startRow` or `endColumn < startColumn`.
  See Also:
    `walkInRowOrder(RealMatrixChangingVisitor)`, `walkInRowOrder(RealMatrixPreservingVisitor)`, `walkInRowOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInRowOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `walkInColumnOrder(RealMatrixChangingVisitor)`, `walkInColumnOrder(RealMatrixPreservingVisitor)`, `walkInColumnOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInOptimizedOrder(RealMatrixChangingVisitor)`, `walkInOptimizedOrder(RealMatrixPreservingVisitor)`, `walkInOptimizedOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInOptimizedOrder(RealMatrixPreservingVisitor, int, int, int, int)`

### walkInOptimizedOrder

    double walkInOptimizedOrder(RealMatrixChangingVisitor visitor)

  Visit (and possibly change) all matrix entries using the fastest possible order.

  The fastest walking order depends on the exact matrix class. It may be different from traditional row or column orders.

  Parameters:
    `visitor` - visitor used to process all matrix entries
  Returns:
    the value returned by `RealMatrixChangingVisitor.end()` at the end of the walk
  See Also:
    `walkInRowOrder(RealMatrixChangingVisitor)`, `walkInRowOrder(RealMatrixPreservingVisitor)`, `walkInRowOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInRowOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `walkInColumnOrder(RealMatrixChangingVisitor)`, `walkInColumnOrder(RealMatrixPreservingVisitor)`, `walkInColumnOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInColumnOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `walkInOptimizedOrder(RealMatrixPreservingVisitor)`, `walkInOptimizedOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInOptimizedOrder(RealMatrixPreservingVisitor, int, int, int, int)`

### walkInOptimizedOrder

    double walkInOptimizedOrder(RealMatrixPreservingVisitor visitor)

  Visit (but don't change) all matrix entries using the fastest possible order.

  The fastest walking order depends on the exact matrix class. It may be different from traditional row or column orders.

  Parameters:
    `visitor` - visitor used to process all matrix entries
  Returns:
    the value returned by `RealMatrixPreservingVisitor.end()` at the end of the walk
  See Also:
    `walkInRowOrder(RealMatrixChangingVisitor)`, `walkInRowOrder(RealMatrixPreservingVisitor)`, `walkInRowOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInRowOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `walkInColumnOrder(RealMatrixChangingVisitor)`, `walkInColumnOrder(RealMatrixPreservingVisitor)`, `walkInColumnOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInColumnOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `walkInOptimizedOrder(RealMatrixChangingVisitor)`, `walkInOptimizedOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInOptimizedOrder(RealMatrixPreservingVisitor, int, int, int, int)`

### walkInOptimizedOrder

    double walkInOptimizedOrder(RealMatrixChangingVisitor visitor,
                                int startRow,
                                int endRow,
                                int startColumn,
                                int endColumn)
                                throws OutOfRangeException,
                                       NumberIsTooSmallException

  Visit (and possibly change) some matrix entries using the fastest possible order.

  The fastest walking order depends on the exact matrix class. It may be different from traditional row or column orders.

  Parameters:
    `visitor` - visitor used to process all matrix entries
    `startRow` - Initial row index
    `endRow` - Final row index (inclusive)
    `startColumn` - Initial column index
    `endColumn` - Final column index (inclusive)
  Returns:
    the value returned by `RealMatrixChangingVisitor.end()` at the end of the walk
  Throws:
    `OutOfRangeException` - if the indices are not valid.
    `NumberIsTooSmallException` - if `endRow < startRow` or `endColumn < startColumn`.
  See Also:
    `walkInRowOrder(RealMatrixChangingVisitor)`, `walkInRowOrder(RealMatrixPreservingVisitor)`, `walkInRowOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInRowOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `walkInColumnOrder(RealMatrixChangingVisitor)`, `walkInColumnOrder(RealMatrixPreservingVisitor)`, `walkInColumnOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInColumnOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `walkInOptimizedOrder(RealMatrixChangingVisitor)`, `walkInOptimizedOrder(RealMatrixPreservingVisitor)`, `walkInOptimizedOrder(RealMatrixPreservingVisitor, int, int, int, int)`

### walkInOptimizedOrder

    double walkInOptimizedOrder(RealMatrixPreservingVisitor visitor,
                                int startRow,
                                int endRow,
                                int startColumn,
                                int endColumn)
                                throws OutOfRangeException,
                                       NumberIsTooSmallException

  Visit (but don't change) some matrix entries using the fastest possible order.

  The fastest walking order depends on the exact matrix class. It may be different from traditional row or column orders.

  Parameters:
    `visitor` - visitor used to process all matrix entries
    `startRow` - Initial row index
    `endRow` - Final row index (inclusive)
    `startColumn` - Initial column index
    `endColumn` - Final column index (inclusive)
  Returns:
    the value returned by `RealMatrixPreservingVisitor.end()` at the end of the walk
  Throws:
    `OutOfRangeException` - if the indices are not valid.
    `NumberIsTooSmallException` - if `endRow < startRow` or `endColumn < startColumn`.
  See Also:
    `walkInRowOrder(RealMatrixChangingVisitor)`, `walkInRowOrder(RealMatrixPreservingVisitor)`, `walkInRowOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInRowOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `walkInColumnOrder(RealMatrixChangingVisitor)`, `walkInColumnOrder(RealMatrixPreservingVisitor)`, `walkInColumnOrder(RealMatrixChangingVisitor, int, int, int, int)`, `walkInColumnOrder(RealMatrixPreservingVisitor, int, int, int, int)`, `walkInOptimizedOrder(RealMatrixChangingVisitor)`, `walkInOptimizedOrder(RealMatrixPreservingVisitor)`, `walkInOptimizedOrder(RealMatrixChangingVisitor, int, int, int, int)`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2003-2013 The Apache Software Foundation. All Rights Reserved.